package org.commonjava.tensor.discover;

import org.apache.maven.graph.common.ref.ProjectVersionRef;
import org.commonjava.tensor.data.TensorDataException;

public interface ProjectRelationshipDiscoverer
{

    /**
     * @param ref the variable/non-concrete ref to resolve versions for
     * @return NEVER null; input ref if no changes made; or resolved ref if successful
     */
    ProjectVersionRef resolveSpecificVersion( ProjectVersionRef ref )
        throws TensorDataException;

    ProjectVersionRef discoverRelationships( ProjectVersionRef projectId, DiscoveryConfig discoveryConfig )
        throws TensorDataException;

}
